=== modified file 'charmworld/models.py'
--- charmworld/models.py	2013-07-09 15:43:56 +0000
+++ charmworld/models.py	2013-07-10 21:11:18 +0000
@@ -16,6 +16,7 @@
 import re
 
 import gridfs
+import magic
 import pymongo
 
 from charmworld.utils import (
@@ -755,6 +756,10 @@
                 "File does not exist: %s (resolving to %s)." % (
                     file_path, real_file_path))
             return
+        if filename == 'icon.svg':
+            if magic.from_file(real_file_path, mime=True) != 'image/svg+xml':
+                logger.warn("File does not an SVG: %s" % file_path)
+                return
         if subdir:
             complete_filename = join(subdir, filename)
         else:

=== modified file 'charmworld/tests/test_models.py'
--- charmworld/tests/test_models.py	2013-07-09 15:43:56 +0000
+++ charmworld/tests/test_models.py	2013-07-10 21:11:18 +0000
@@ -873,10 +873,21 @@
         self.assertEqual(expected, messages)
         self.assertEqual([], files)
 
+    def test_save_file_ignores_invalid_icons(self):
+        path = self.use_context(temp_dir())
+        with file(join(path, 'icon.svg'), 'w') as f:
+            f.write('foo')
+        files = CharmFileSet.save_files(
+            self.fs,
+            self.charm_data,
+            path,
+            self.logger)
+        self.assertEqual([], files)
+
     def test_provides_content_type(self):
         path = self.use_context(temp_dir())
         with file(join(path, 'icon.svg'), 'w') as f:
-            f.write('foo')
+            f.write('<?xml version="1.0"?><svg></svg>')
         with file(join(path, 'readme.txt'), 'w') as f:
             f.write('foo')
         CharmFileSet.save_files(

=== modified file 'requirements.txt'
--- requirements.txt	2013-04-12 18:35:15 +0000
+++ requirements.txt	2013-07-10 21:11:18 +0000
@@ -44,6 +44,7 @@
 pyramid-debugtoolbar==1.0.3
 pyramid_exclog==0.6
 python-dateutil==2.1
+python-magic==0.4.3
 python-openid==2.2.5
 PyYAML==3.10
 repoze.lru==0.4

